/*
 * ProbeData
 *
 * A class that represents a data entry
 */



static final char lonPre = 'X', latPre = 'Y', phPre = 'P';
class probeData {
  float lon; // X
  float lat; // Y
  float ph ; // PH
  boolean phRecv = false;
  boolean lonRecv = false;
  boolean latRecv = false; 
  String timeString;

  probeData(Serial s) {
    //Read the lines
    lon = 0;
    ph  = 0;
    lat = 0;
  }

  boolean isFull() {
    boolean a = phRecv && latRecv && lonRecv;
    if (a) timeString = getTimeString();
    return a;
  }

  void readParseSerialLine(char inchar, String numStr) {
    numStr = numStr.trim();
    // Checking for invalid strings 
    println("[DATA]: "  + inchar + " : "  + numStr);
    if ( numStr.length() < 2 || numStr.contains("\n") || numStr.contains("\r")) {
      println("[ENTRY] invalid input");
      return;
    }
   
    float num = Float.valueOf(numStr);
   
    // Choosing the variable to put the number into
    switch(inchar) {
    case phPre: //PH
      ph = num;
      phRecv = true;
      break;
    case lonPre: //Longtitude
      lon = num;
      lonRecv = true;
      break;
    case latPre: //Latitude
      lat = num;
      latRecv = true; 
      break;
    default:
      println("[ENTRY] Unexpected input: " + inchar);
    }
  }

  //Returns a string representation of the string
  String getCSVDataLine() {
    return String.format("%s;%f,%f,%f", timeString, lon, lat, ph);
  }
  //Returns the values in an array
  float[] getData(){
    return new float[]{lon,lat,ph};
  }
}
